def factorial(n: int) -> int:
    if n == 0:
        return 1
    else:
        return n * factorial(n - 1)


def length[A](l: list[A]) -> int:
    match l:
        case [_, *t]:
            return 1 + length(t)
        case _:
            return 0


def hd[A](l: list[A]) -> A:
    match l:
        case [h, *_]:
            return h
        case _:
            raise ValueError


def head[A](l: list[A]) -> A | None:
    match l:
        case [h, *_]:
            return h
        case _:
            return None


def get_item[A](l: list[A]) -> tuple[A, list[A]] | None:
    match l:
        case [h, *t]:
            return (h, t)
        case _:
            return None


def last[A](l: list[A]) -> A:
    match l:
        case [h]:
            return h
        case [_, *t]:
            return last(t)
        case _:
            raise ValueError


def nth[A](l: list[A], i: int) -> A:
    match l:
        case [h, *t]:
            if i == 0:
                return h
            else:
                return nth(t, i - 1)
        case _:
            raise IndexError


def take[A](l: list[A], i: int) -> list[A]:
    if i == 0:
        return []
    else:
        match l:
            case [h, *t]:
                return [h, *take(t, i - 1)]
            case _:
                raise IndexError


def drop[A](l: list[A], i: int) -> list[A]:
    if i == 0:
        return l
    else:
        match l:
            case [_, *t]:
                return drop(t, i - 1)
            case _:
                raise IndexError


def reversed[A](l: list[A]) -> list[A]:
    match (l):
        case [h, *t]:
            return reversed(t) + [h]
        case _:
            return []


def concat[A](l: list[list[A]]) -> list[A]:
    match (l):
        case [h, *t]:
            return h + concat(t)
        case _:
            return []
